// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/components/ui/UIComponentRenderable.hpp"
#include "display/mesh/QuadMesh.hpp"

namespace Dawn {
  class UILabelNew : public UIComponentRenderable {
    protected:
      Mesh mesh;
    FontShaderBuffer shaderBuffer;

    public:
      UILabelNew(SceneItem *item);

      void onStart() override;
      std::vector<struct ShaderPassItem> getUIRenderPasses() override;
      float_t getWidth() override;
      float_t getHeight() override;
      float_t getContentWidth() override;
      float_t getContentHeight() override;
  };
}