// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "UIShader.hpp"
#include "util/macro.hpp"

#define FONT_SHADER_PARTS_MAX 16
#define FONT_SHADER_QUADS_MAX 16

namespace Dawn {
  struct FontShaderPart {
    struct Color color;
  };

  struct FontShaderBufferData {
    struct FontShaderPart fontParts[FONT_SHADER_PARTS_MAX];
    int32_t fontQuadParts[FONT_SHADER_QUADS_MAX];
  };

  class FontShaderBuffer : public ShaderParameterBuffer<struct FontShaderBufferData> {

  };

  class FontShader : public Shader {
    public:
      shaderparameter_t paramModel;
      shaderbufferlocation_t bufferUiCanvas;
      shaderbufferlocation_t bufferFont;

      void compile() override;
  };
}